/*
 * Copyright 2009
 *     PYRASIS.COM
 *
 * Author:
 *     Lee Jae-Hong (pyrasis)
 */

#include <time.h>
#include <ntddk.h>
#include <ntdef.h>

typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef int errno_t;

typedef struct _FILETIME {
	DWORD dwLowDateTime;
	DWORD dwHighDateTime;
} FILETIME, *PFILETIME, *LPFILETIME;

typedef struct _SYSTEMTIME {
	WORD wYear;
	WORD wMonth;
	WORD wDayOfWeek;
	WORD wDay;
	WORD wHour;
	WORD wMinute;
	WORD wSecond;
	WORD wMilliseconds;
} SYSTEMTIME, *PSYSTEMTIME, *LPSYSTEMTIME;

typedef struct _OVERLAPPED {
	ULONG_PTR Internal;
	ULONG_PTR InternalHigh;
	union {
		struct {
			DWORD Offset;
			DWORD OffsetHigh;
		};

		PVOID Pointer;
	};

	HANDLE  hEvent;
} OVERLAPPED, *LPOVERLAPPED;

__inline errno_t localtime_s(struct tm * _Tm, const time_t * _Time)
{
	LARGE_INTEGER systemTime, localTime;
	TIME_FIELDS timeFields;

	KeQuerySystemTime(&systemTime);
	ExSystemTimeToLocalTime(&systemTime, &localTime);

	RtlTimeToTimeFields(&localTime, &timeFields);

	_Tm->tm_sec = timeFields.Second;
	_Tm->tm_min = timeFields.Minute;
	_Tm->tm_hour = timeFields.Hour;
	_Tm->tm_mday = timeFields.Day;
	_Tm->tm_mon = timeFields.Month;
	_Tm->tm_year = timeFields.Year;
	_Tm->tm_wday = timeFields.Weekday;

	return 0;
}

__inline void GetSystemTime(__out LPSYSTEMTIME lpSystemTime)
{
	LARGE_INTEGER systemTime;
	TIME_FIELDS timeFields;

	KeQuerySystemTime(&systemTime);

	RtlTimeToTimeFields(&systemTime, &timeFields);
}

__inline void GetSystemTimeAsFileTime(__out LPFILETIME lpSystemTimeAsFileTime)
{
	KeQuerySystemTime((PLARGE_INTEGER)&lpSystemTimeAsFileTime);
}

#define MultiByteToWideChar(a,b,c,d,e,f) 0
#define WideCharToMultiByte(a,b,c,d,e,f,g,h) 0
#define AreFileApisANSI() 0

#define CreateFileW(a,b,c,d,e,f,g) 0
#define CreateFileA(a,b,c,d,e,f,g) 0
#define ReadFile(a,b,c,d,e) 0
#define WriteFile(a,b,c,d,e) 0
#define DeleteFileW(a) 0
#define DeleteFileA(a) 0
#define GetFileAttributesW(a) 0
#define GetFileAttributesA(a) 0
#define GetFullPathNameW(a,b,c,d) 0
#define GetFullPathNameA(a,b,c,d) 0
#define GetDiskFreeSpaceW(a,b,c,d,e) 0
#define GetDiskFreeSpaceA(a,b,c,d,e) 0
#define LoadLibraryW(a) 0
#define LoadLibraryA(a) 0
#define FreeLibrary(a) 0
#define GetProcAddress(a,b) 0
#define LockFileEx(a,b,c,d,e,f) 0
#define LockFile(a,b,c,d,e) 0
#define UnlockFile(a,b,c,d,e) 0
#define SetEndOfFile(a) 0
#define FlushFileBuffers(a) 0
#define GetTempPathW(a,b) 0
#define GetTempPathA(a,b) 0
#define FormatMessageA(a,b,c,d,e,f,g) 0
#define GetCurrentProcessId() 0
#define GetTickCount() 0
#define QueryPerformanceCounter(a) *a.LowPart = 0

#define CloseHandle(a) 0
#define Sleep(a) 0

#define SetFilePointer(a,b,c,d) 0
#define GetLastError() 0

#define MAX_PATH 260
#define FILE_BEGIN 0
#define NO_ERROR 0

#define CP_ACP 0
#define CP_OEMCP 1

NTSYSAPI
NTSTATUS
NTAPI
ZwDeleteFile(
    __in POBJECT_ATTRIBUTES ObjectAttributes
    );

#define INVALID_FILE_SIZE ((DWORD)0xFFFFFFFF)
